src/ATKS/AdminBundle/Entity/Image.php
<?php

namespace ATKS\AdminBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Image
 *
 * @ORM\Table(name="ps_image")
 * @ORM\Entity(repositoryClass="ATKS\AdminBundle\Entity\ImageRepository")
 * @ORM\HasLifecycleCallbacks
 */
class Image
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="url", type="string", length=255, nullable=true)
     */
    private $url;

    /**
     * @var string
     *
     * @ORM\Column(name="alt", type="string", length=255, nullable=true)
     */
    private $alt;
    
    /**
     * @Assert\File(
     *      maxSize="1M",
     *      mimeTypes = {"image/png", "image/jpeg"},
     *      mimeTypesMessage = "Choisissez une image valide",
     *      maxSizeMessage = "L'image choisie est trop grande"
     * )
     */
    public $file;
    
    public $tempFilename;
    
    public function setFile(UploadedFile $file) {
        $this->file = $file;
        if (null !== $this->url) {
            $this->tempFilename = $this->url;
            $this->url = null;
        }
    }
    
    
    /**
     * @ORM\PrePersist()
     * @ORM\PreUpdate()
     */
    public function preUpload() {
        if (null === $this->file) {
            return;
        }
        $this->url = $this->file->guessExtension();
        $this->alt = $this->file->getClientOriginalName();
    }

    /**
     * @ORM\PostPersist()
     * @ORM\PostUpdate()
     */
    public function upload() {
        if (null === $this->file) {
            return;
        }
        if (null !== $this->tempFilename) {
            $oldFile = $this->getUploadRootDir() . '/' . $this->id . '.' . $this->tempFilename;
            if (file_exists($oldFile)) {
                unlink($oldFile);
            }
        }
        $this->file->move(
                $this->getUploadRootDir(), $this->id . '.' . $this->url
        );
    }

    /**
     * @ORM\PreRemove()
     */
    public function preRemoveUpload() {
        $this->tempFilename = $this->getUploadRootDir() . '/' . $this->id . '.' . $this->url;
    }

    /**
     * @ORM\PostRemove()
     */
    public function removeUpload() {
        if (file_exists($this->tempFilename)) {
            unlink($this->tempFilename);
        }
    }

    public function getUploadDir() {
        return 'uploads/images';
    }

    protected function getUploadRootDir() {
        return __DIR__ . '/../../../../web/' . $this->getUploadDir();
    }

    public function getWebPath() {
        return $this->getUploadDir() . '/' . $this->getId() . '.' . $this->getUrl();
    }



    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set url
     *
     * @param string $url
     * @return Image
     */
    public function setUrl($url)
    {
        $this->url = $url;
    
        return $this;
    }

    /**
     * Get url
     *
     * @return string 
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * Set alt
     *
     * @param string $alt
     * @return Image
     */
    public function setAlt($alt)
    {
        $this->alt = $alt;
    
        return $this;
    }

    /**
     * Get alt
     *
     * @return string 
     */
    public function getAlt()
    {
        return $this->alt;
    }
}

src/ATKS/AdminBundle/Controller/CentreSanteUserController.php
<?php

namespace ATKS\AdminBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;

class CentreSanteUserController extends Controller
{
    public function listHopitalAction($page)
    {
        $em = $this->getDoctrine()
                ->getManager();
        $premierHopital = ($page - 1) * 100;
        $totalHopital = $em->getRepository("ATKSAdminBundle:HopitalUser")->nbreHopital();
        $totalPages = ceil(intval($totalHopital) / 100);
        $hopitaux = $em
                ->getRepository("ATKSAdminBundle:HopitalUser")
                ->findBy(array(), array("id" => "DESC"), 100, $premierHopital);
        return $this->render('ATKSAdminBundle:CentreSanteUser:listHopital.html.twig', array(
                    'page' => $page,
                    'nbrTotalPages' => $totalPages,
                    'hopitaux' => $hopitaux
        ));
    }
    
    public function marquerHopitauxVueAction(){
        $em = $this->getDoctrine()->getManager();
        $hopitauxNonVu = $em
                ->getRepository("ATKSAdminBundle:HopitalUser")
                ->findBy(array("vue"=>false), array());
        foreach($hopitauxNonVu as $h){
            $h->setVue(true);
        }
        $em->flush();
        return $this->redirect($this->generateUrl('atks_admin_list_hopital_soumis_user'));
    }
    
    public function marquerHopitalVueAction($id){
        $em = $this->getDoctrine()
                ->getManager();
        $hopital = $em->getRepository("ATKSAdminBundle:HopitalUser")->find($id);
        if($hopital->getVue()==true){
            $hopital->setVue(false);
        }else{
            $hopital->setVue(true);
        }
        $em->persist($hopital);
        $em->flush();
        return $this->redirect($this->generateUrl('atks_admin_list_hopital_soumis_user'));
    }
    
    public function supprimerHopitalAction($id) {
        $em = $this->getDoctrine()->getEntityManager();
        $hopital = $em->getRepository("ATKSAdminBundle:HopitalUser")
                ->find($id);
        if ($hopital === null) {
            throw $this->createNotFoundException('Cet hopital n\'existe pas');
        }
        $em->remove($hopital);
        $em->flush();
        $this->get('session')->getFlashBag()->add('success', 'Hopital supprimé avec succès');
        return $this->redirect($this->generateUrl('atks_admin_list_hopital_soumis_user'));
    }
    
    public function listPharmacieAction($page)
    {
        $em = $this->getDoctrine()
                ->getManager();
        $premierePharmacie = ($page - 1) * 100;
        $totalPharmacie = $em->getRepository("ATKSAdminBundle:PharmacieUser")->nbrePharmacie();
        $totalPages = ceil(intval($totalPharmacie) / 100);
        $pharmacies = $em
                ->getRepository("ATKSAdminBundle:PharmacieUser")
                ->findBy(array(), array("id" => "DESC"), 100, $premierePharmacie);
        return $this->render('ATKSAdminBundle:CentreSanteUser:listPharmacie.html.twig', array(
                    'page' => $page,
                    'nbrTotalPages' => $totalPages,
                    'pharmacies' => $pharmacies
        ));
    }
    
    public function marquerPharmaciesVueAction(){
        $em = $this->getDoctrine()->getManager();
        $pharmaciesNonVu = $em
                ->getRepository("ATKSAdminBundle:PharmacieUser")
                ->findBy(array("vue"=>false), array());
        foreach($pharmaciesNonVu as $h){
            $h->setVue(true);
        }
        $em->flush();
        return $this->redirect($this->generateUrl('atks_admin_list_pharmacie_soumis_user'));
    }
    
    public function marquerPharmacieVueAction($id){
        $em = $this->getDoctrine()
                ->getManager();
        $pharmacie = $em->getRepository("ATKSAdminBundle:PharmacieUser")->find($id);
        if($pharmacie->getVue()==true){
            $pharmacie->setVue(false);
        }else{
            $pharmacie->setVue(true);
        }
        $em->persist($pharmacie);
        $em->flush();
        return $this->redirect($this->generateUrl('atks_admin_list_pharmacie_soumis_user'));
    }
    
    public function supprimerPharmacieAction($id) {
        $em = $this->getDoctrine()->getEntityManager();
        $pharmacie = $em->getRepository("ATKSAdminBundle:PharmacieUser")
                ->find($id);
        if ($pharmacie === null) {
            throw $this->createNotFoundException('Cette pharmacie n\'existe pas');
        }
        $em->remove($pharmacie);
        $em->flush();
        $this->get('session')->getFlashBag()->add('success', 'Pharmacie supprimée avec succès');
        return $this->redirect($this->generateUrl('atks_admin_list_pharmacie_soumis_user'));
    }
}

src/ATKS/AdminBundle/Resources/views/CentreSanteUser/listHopital.html.twig
{%extends "ATKSAdminBundle::layout.html.twig"%}
{%block title%}{{parent()}} Les hôpitaux{%endblock title%}
{% block body %}
{{parent()}}
<a class="button large primary" href="{{path('atks_admin_marquer_hopitaux_vue')}}">
    <i class="icon-eye"></i>
    Marquer tout vue
</a>
<div class="grid fluid">
    <div class="row">
        <h2 id="__form__">Les hôpitaux soumis par les utilisateurs</h2>
        <div class="example2" style="padding: 10px">
            <table class="table striped hovered dataTable" id="dataTables-1">
                <thead>
                    <tr>
                        <th class="text-left" style="width: 5%">Image</th>
                            <th class="text-left" style="width: 10%">Utilisateur</th>
                            <th class="text-left" style="width: 20%">Nom</th>
                            <th class="text-left" style="width: 5%">Type</th>
                            <th class="text-left" style="width: 10%">Adresse</th>
                            <th class="text-left" style="width: 15%">Contact</th>
                            <th class="text-left" style="width: 5%">Coord. géo.</th>
                            <th class="text-left" style="width: 15%">Services de santé ID</th>
                            <th class="text-left" style="width: 15%">Action</th>
                    </tr>
                </thead>

                <tbody>
                    {%for h in hopitaux%}
                        <tr style="{%if h.vue==false%}background: #78aa1c{%endif%}">
                            <td>
                                {%if h.image%}
                                    <img src="{{asset(h.image.webPath)}}" style="width: 60px; height: 60px"/>
                                {%else%}
                                <img src="{{asset('bundles/atksadmin/images/caducee-pharmacie.jpg')}}" style="width: 60px; height: 60px"/>
                                {%endif%}
                            </td>
                            <td>
                                {{h.nomUser|upper}} {{h.prenomUser}} <br/>
                                ({{h.emailUser}})<br/>
                                {{h.telephoneUser}}
                            </td>
                            <td>{{h.nom}}</td>
                            <td>{{h.type}}</td>
                            <td>{{h.adresse}}</td>
                            <td>
                                {%if h.telephone%}Tél: {{h.telephone}}<br/>{%endif%}
                                {%if h.fax%}Fax: {{h.fax}}<br/>{%endif%}
                                {%if h.email%}Email: <a href="mailto:{{h.email}}">{{h.email}}</a><br/>{%endif%}
                                {%if h.siteWeb%}Site web: <a href="http://{{h.siteWeb}}">{{h.siteWeb}}</a>{%endif%}
                            </td>
                            <td> 
                                Lat: {{h.latitude}}<br/>
                                Lon: {{h.longitude}}<br/>
                            </td>
                            <td> 
                                {{h.serviceSantesId}}
                            </td>
                            <td>
                                <div class="toolbar" style="float: right">
                                    <a class="button js-show-all-streams" title="" data-role="" href="{{path('atks_admin_marquer_hopital_vue', {'id':h.id})}}"><span class="icon-eye"></span></a>
                                    <a href="{{path('atks_admin_supprimer_hopital_user', {'id':h.id})}}" class="button js-show-all-streams" title="Supprimer" data-role=""><span class="icon-remove"></span></a>
                                </div>
                            </td>
                        </tr>
                    {%endfor%}
                    </tbody>

                    <tfoot>
                        <tr>
                            <th class="text-left" style="width: 5%">Image</th>
                            <th class="text-left" style="width: 10%">Utilisateur</th>
                            <th class="text-left" style="width: 20%">Nom</th>
                            <th class="text-left" style="width: 5%">Type</th>
                            <th class="text-left" style="width: 10%">Adresse</th>
                            <th class="text-left" style="width: 15%">Contact</th>
                            <th class="text-left" style="width: 5%">Coord. géo.</th>
                            <th class="text-left" style="width: 15%">Services de santé ID</th>
                            <th class="text-left" style="width: 15%">Action</th>
                        </tr>
                    </tfoot>
                </table>
                {%if hopitaux|length>0%}
                <div class="pagination" style="margin-top: 20px">
                    <ul>
                        <li class="first"><a {%if page==1%}class="disabled" {%endif%} href="{{path('atks_admin_list_hopital_soumis_user', {'page': 1})}}"><i class="icon-first-2"></i></a></li>
                        <li class="prev"><a {%if page-1<1%}class="disabled" {%endif%} href="{{path('atks_admin_list_hopital_soumis_user', {'page': page-1})}}"><i class="icon-previous"></i></a></li>
                        {%for i in 1..nbrTotalPages%}
                        <li><a href="{{path('atks_admin_list_hopital_soumis_user', {'page': i})}}" {%if page==i%}class="disabled" {%endif%}>{{i}}</a></li>
                        {%endfor%}
                        <li class="next"><a {%if page+1>nbrTotalPages%}class="disabled" {%endif%} href="{{path('atks_admin_list_hopital_soumis_user', {'page': page+1})}}"><i class="icon-next"></i></a></li>
                        <li class="last"><a {%if page==nbrTotalPages%}class="disabled" {%endif%} href="{{path('atks_admin_list_hopital_soumis_user', {'page': nbrTotalPages})}}"><i class="icon-last-2"></i></a></li>
                    </ul>
                </div>
                {%endif%}
            </div>
        </div>
    </div>
{% endblock body %}
{% block javascripts %}
{{parent()}}
    <script>
        $(function() {
            $('#dataTables-1').dataTable({
                "bProcessing": true,
            });
        });
        </script>
{% endblock javascripts %}

src/ATKS/AdminBundle/Resources/views/CentreSanteUser/listPharmacie.html.twig
{%extends "ATKSAdminBundle::layout.html.twig"%}
{%block title%}{{parent()}} Liste des pharmacies soumises par les utilisateurs{%endblock title%}
{% block body %}
{{parent()}}
<a class="button large primary" href="{{path('atks_admin_marquer_pharmacies_vue')}}">
    <i class="icon-eye"></i>
    Marquer tout vue
</a>
<div class="grid fluid">
    <div class="row">
        <h2 id="__form__">Liste des pharmacies soumises par les utilisateurs</h2>
        <div class="example2" style="padding: 10px">
            <table class="table striped hovered dataTable" id="dataTables-1">
                <thead>
                    <tr>
                            <th class="text-left" style="width: 5%">Image</th>
                            <th class="text-left" style="width: 10%">Utilisateur</th>
                            <th class="text-left" style="width: 15%">Nom</th>
                            <th class="text-left" style="width: 10%">Adresse</th>
                            <th class="text-left" style="width: 10%">Contact</th>
                            <th class="text-left" style="width: 5%">Horaire d'ouverture</th>
                            <th class="text-left" style="width: 10%">Pharmacien</th>
                            <th class="text-left" style="width: 10%">Coord. géo.</th>
                            <th class="text-left" style="width: 10%">Spéc. ID</th>
                            <th class="text-left" style="width: 15%">Action</th>
                    </tr>
                </thead>

                <tbody>
                    {%for p in pharmacies%}
                        <tr style="{%if p.vue==false%}background: #78aa1c{%endif%}">
                            <td>
                                {%if p.image%}
                                    <img src="{{asset(p.image.webPath)}}" style="width: 60px; height: 60px"/>
                                {%else%}
                                <img src="{{asset('bundles/atksadmin/images/caducee-pharmacie.jpg')}}" style="width: 60px; height: 60px"/>
                                {%endif%}
                            </td>
                            <td>
                                {{p.nomUser|upper}} {{p.prenomUser}}<br/>
                                    ({{p.emailUser}})<br/>
                                    {{p.telephoneUser}}
                            </td>
                            <td>{{p.nom}}</td>
                            <td>{{p.adresse}}</td>
                            <td> 
                                {%if p.telephone%}Tél: {{p.telephone}}{%endif%}<br/>
                                {%if p.fax%}Fax: {{p.fax}}{%endif%}<br/>
                                {%if p.email%}Email: <a href="mailto:{{p.email}}">{{p.email}}</a>{%endif%}<br/>
                                {%if p.siteWeb%}Site Web: <a href="http://{{p.siteWeb}}">{{p.siteWeb}}</a>{%endif%}<br/>
                            </td>
                            <td> 
                                {{p.heureOuverture|date('H')}}H - {{p.heureFermeture|date('H')}}H
                            </td>
                            <td> 
                                {{p.nomPharmacien}} ({{p.qualificationPharmacien}})
                            </td>
                            <td> 
                                Lon: {{p.longitude}}<br/>
                                Lat: {{p.latitude}}
                            </td>
                            <td> 
                                {{p.specialiteId}}
                            </td>
                            <td>
                                <div class="toolbar" style="float: right">
                                    <a href="{{path('atks_admin_marquer_pharmacie_vue', {'id':p.id})}}" class="button js-show-all-streams" title="" data-role=""><span class="icon-eye"></span></a>
                                    <a href="{{path('atks_admin_supprimer_pharmacie_user', {'id':p.id})}}" class="button js-show-all-streams" title="Supprimer" data-role=""><span class="icon-remove"></span></a>
                                </div>
                            </td>
                        </tr>
                    {%endfor%}
                    </tbody>

                    <tfoot>
                        <tr>
                            <th class="text-left" style="width: 5%">Image</th>
                            <th class="text-left" style="width: 10%">Utilisateur</th>
                            <th class="text-left" style="width: 15%">Nom</th>
                            <th class="text-left" style="width: 10%">Adresse</th>
                            <th class="text-left" style="width: 10%">Contact</th>
                            <th class="text-left" style="width: 5%">Horaire d'ouverture</th>
                            <th class="text-left" style="width: 10%">Pharmacien</th>
                            <th class="text-left" style="width: 10%">Coord. géo.</th>
                            <th class="text-left" style="width: 10%">Spéc. ID</th>
                            <th class="text-left" style="width: 15%">Action</th>
                        </tr>
                    </tfoot>
                </table>
                {%if pharmacies|length>0%}
                <div class="pagination" style="margin-top: 20px">
                    <ul>
                        <li class="first"><a {%if page==1%}class="disabled" {%endif%} href="{{path('atks_admin_list_pharmacie_soumis_user', {'page': 1})}}"><i class="icon-first-2"></i></a></li>
                        <li class="prev"><a {%if page-1<1%}class="disabled" {%endif%} href="{{path('atks_admin_list_pharmacie_soumis_user', {'page': page-1})}}"><i class="icon-previous"></i></a></li>
                        {%for i in 1..nbrTotalPages%}
                        <li><a href="{{path('atks_admin_list_pharmacie_soumis_user', {'page': i})}}" {%if page==i%}class="disabled" {%endif%}>{{i}}</a></li>
                        {%endfor%}
                        <li class="next"><a {%if page+1>nbrTotalPages%}class="disabled" {%endif%} href="{{path('atks_admin_list_pharmacie_soumis_user', {'page': page+1})}}"><i class="icon-next"></i></a></li>
                        <li class="last"><a {%if page==nbrTotalPages%}class="disabled" {%endif%} href="{{path('atks_admin_list_pharmacie_soumis_user', {'page': nbrTotalPages})}}"><i class="icon-last-2"></i></a></li>
                    </ul>
                </div>
                {%endif%}
            </div>
        </div>
    </div>
{% endblock body %}
{% block javascripts %}
{{parent()}}
    <script>
        $(function() {
            $('#dataTables-1').dataTable({
                "bProcessing": true,
            });
        });
        </script>
{% endblock javascripts %}